//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "CM100U_PMAPI.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

BYTE BOARD = 1;
BYTE Main_PMIDCount,Main_PMIDArray[45];

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
   CM100PM_CloseBoard(BOARD);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_GetFirmwareVerClick(TObject *Sender)
{
  DWORD Ver;
  AnsiString Str;

  Ver = CM100PM_GetFirmwareVersion(BOARD);
  Str.printf("Ver:%X",Ver);
  ShowMessage(Str);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_SetBaudRateClick(TObject *Sender)
{
  DWORD Ret;
  AnsiString Str;

  Ret = CM100PM_SetBaudRate(BOARD,ComboBox_BaudRate->ItemIndex);
  Str.printf("Error(%d)",Ret);
  if(Ret) ShowMessage(Str);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_BaudRateClick(TObject *Sender)
{
  DWORD Ret;
  AnsiString Str;
  BYTE BaudRate;

  Ret = CM100PM_GetBaudRate(BOARD,&BaudRate);
  Str.printf("Error(%d)",Ret);
  if(Ret) ShowMessage(Str);
  switch(BaudRate)
  {
    case 0: ShowMessage("125K bps"); break;
    case 1: ShowMessage("250K bps"); break;
    case 2: ShowMessage("500K bps"); break;
    default: ShowMessage("Unknown"); break;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_GetPMIDsClick(TObject *Sender)
{
  BYTE PMIDCount,bTemp,PMIDArray[45],Sorted[45];
  AnsiString Str1,Str2;
  BYTE i,j,temp;
  DWORD Ret;

  Ret = CM100PM_GetPMIDs(BOARD,&PMIDCount,PMIDArray);
  if(Ret){ShowMessage("Error : " + Ret); return;}


  Str1 = "";
  for(j = 0;j < PMIDCount;j++)
  {
    if(j == (PMIDCount-1))
      Str2.printf("%d;",PMIDArray[j]);
    else
      Str2.printf("%d,",PMIDArray[j]);
    Str1 += Str2;
  }
  Str2.printf("Count: %d",PMIDCount);
  Str1 += Str2;
  ShowMessage(Str1);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button_ReadAllDataClick(TObject *Sender)
{
  BYTE PMIDCount,bTemp,PMIDArray[45],Sorted[45];
  AnsiString Str1,Str2;
  BYTE i,j,temp;
  DWORD Ret;

  Ret = CM100PM_GetPMIDs(BOARD,&Main_PMIDCount,Main_PMIDArray);
  if(Ret){ShowMessage("Error : " + Ret); return;}


}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_GetAutoRespTimeClick(TObject *Sender)
{
  DWORD AutoRespTime;
  CM100PM_GetAutoRespTime(BOARD,&AutoRespTime);
  ShowMessage(AutoRespTime);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_SetAutoRespTimeClick(TObject *Sender)
{
  CM100PM_SetAutoRespTime(BOARD,1000);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton_ActiveBoardClick(TObject *Sender)
{
  DWORD Ret;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton_ResetFirmwareClick(TObject *Sender)
{
  CM100PM_ResetFirmware(BOARD);
  Sleep(1000);

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_GetCANStatusClick(TObject *Sender)
{
  BYTE CANStatus;
  AnsiString Str;

  CM100PM_GetCANStatus(BOARD, &CANStatus);


  if(CANStatus)
  {
    Str.printf("CANStatus %d",CANStatus);
    ShowMessage(Str);
  }
  else
    ShowMessage("CANStatus OK");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton_StartAutoRespClick(TObject *Sender)
{
   CM100PM_StartAutoResp(BOARD);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton_StopAutoRespClick(TObject *Sender)
{
  CM100PM_StopAutoResp(BOARD);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ActiveClick(TObject *Sender)
{
  DWORD Ret;
  AnsiString Str;

  Ret = CM100PM_ActiveBoard(BOARD);
  if(Ret)
  {
    Str.printf("ActiveBoard Error(%d)",Ret);
    ShowMessage(Str);
  }
}
//---------------------------------------------------------------------------


